# Programa para ordenar un conjunto
# de puntos en orden circular

import sys

n = len( sys.argv )
if n != 2 :
	print( "Args: nombre_archivo" )
	sys.exit(1)

nombre = sys.argv[1]

pivote = []

class Punto :
	def __init__( self, x, y ) :
		self.x = x
		self.y = y

	def __lt__ ( self, b ) :
		ux = self.x - pivote.x 
		uy = self.y - pivote.y 
		vx = b.x - pivote.x
		vy = b.y - pivote.y
		v = ux * vy - vx * uy
		if v > 0 :
			return True
		elif v < 0 :
			return False
		else :
			d1 = ux*ux + uy*uy
			d2 = vx*vx + vy*vy
			if d1 < d2 :
				return True 
			else :
				return False 


# Entrada el conjunto de puntos en un
# archivo
def leer_archivo( nombre ) :
	try :
		arch = open( nombre, "r" )
	except:
		print( "No puede abrir el archivo", nombre )
		sys.exit(2)

	L = []
	while 1 :
		linea = arch.readline( )
		if linea == "" :
			break
		l = linea.split( sep=' ' )
		n = len( l )
		if n != 2 :
			continue
		else :
			L.append( Punto( int(l[0]), int(l[1]) ) )

	return L
		

# Aqui empieza el algoritmo
Lista = leer_archivo( nombre )
n = len( Lista )
print( "# ", n )

# Paso 1
# Encontrar el menor elemento en 'y'
imenory = 0
i = 1
while i < n :
	if Lista[i].y < Lista[imenory].y :
		imenory = i
	i += 1

# Paso 2
# Encontrar el menor elemento en si hay varios
# elementos con el 'y' minimo
imenorx = imenory
i = 0
while i < n :
	if Lista[i].y == Lista[imenorx].y and  Lista[i].x < Lista[imenorx].x :
		imenorx = i
	i += 1

# Paso 3
pivote = Lista.pop( imenorx )
n -= 1

# Paso 4
Lista.sort( )

# Imprimimos la lista ordenada
print( pivote.x, pivote.y )
i = 0
while i < n :
	print( Lista[i].x, Lista[i].y )
	i += 1

